import QtQuick 2.4
import Ubuntu.Components 1.3
//import Fingerprintgpu 1.0

Rectangle {
    width: units.gu(140)
    height: units.gu(100)

    color: Qt.rgba(0.99, 0.99, 0.99, 1.0)

    Row {
        anchors.centerIn: parent
        spacing: units.gu(5)

        BorderImage {
            id: shapeUp
            width: units.gu(26)
            height: units.gu(28)
            source: shapeArea.pressed ? "shape-down.sci" : "shape-up.sci"
            MouseArea {
                id: shapeArea
                anchors.fill: parent
            }
        }

        CircularSegment {
            NumberAnimation on angleStop {
                from: 0
                to: 360
                duration: UbuntuAnimation.SlowDuration
                easing: UbuntuAnimation.StandardEasing
            }
            NumberAnimation on thickness {
                from: 0
                to: units.dp(3)
                duration: UbuntuAnimation.SlowDuration
                easing: UbuntuAnimation.StandardEasing
            }
        }

        Column {
            spacing: units.gu(4)

            SegmentRenderer {
                id: segmentRenderer

                source: "test_segmented.png"
//                source: "fingerprint_segmented.png"
                segmentsCount: segmentBoundingBoxes.count

                function enrollMasks(masks) {
                    if (masks && masks.length) {
                        var segments = [];
                        masks.forEach(function (mask, i) {
                            var hitBox = [mask.x, mask.y, mask.width, mask.height];
                            print(hitBox)
                            segments = segments.concat(segmentBoundingBoxes.computeIntersections(hitBox));
                        });
                        segmentRenderer.animate(segments);
                    }
                }

                MouseArea {
                    id: segmentMouse
                    anchors.fill: parent
                    property real boxSize: units.dp(10)
                    onClicked: {
                        rectclick.visible = true

                        var hitBox = {};
                        hitBox.x = (mouse.x - boxSize) / segmentMouse.width;
                        hitBox.y = (mouse.y - boxSize) / segmentMouse.height;
                        hitBox.width = boxSize * 2.0 / segmentMouse.width;
                        hitBox.height = boxSize * 2.0 / segmentMouse.height;
                        segmentRenderer.enrollMasks([hitBox]);
                    }
                }
                Rectangle {
                    id: rectclick
                    color: "red"
                    opacity: 0.3
                    x: segmentMouse.mouseX - segmentMouse.boxSize
                    y: segmentMouse.mouseY - segmentMouse.boxSize
                    width: segmentMouse.boxSize * 2.0
                    height: segmentMouse.boxSize * 2.0
                    visible: false
                }
            }

            SegmentBoundingBoxes {
                id: segmentBoundingBoxes
                source: "test_boxes.json"
//                source: "fingerprint_boxes.json"
            }
        }
    }
}
